DECLARE FUNCTION Mark.Dettinger! (jour AS INTEGER, mois AS INTEGER, annee AS INTEGER)
DECLARE FUNCTION Mike.Keith! (jour AS INTEGER, mois AS INTEGER, annee AS INTEGER)
DECLARE FUNCTION JourSemaine! (jour AS INTEGER, mois AS INTEGER, annee AS INTEGER)
DECLARE FUNCTION nbrjours! (mois AS INTEGER, annee AS INTEGER)
'$INCLUDE: 'includes\guilib.bi'
'$INCLUDE: 'includes\session.bi'

DIM jour AS INTEGER
DIM mois AS INTEGER
DIM annee AS INTEGER
DIM TableauJour(1 TO 7) AS STRING * 2
DIM TableauMois(1 TO 12) AS STRING * 10
DIM BtnJours(1 TO 31) AS Button
DIM PrevMois AS Button
DIM NextMois AS Button
DIM PrevAnnee AS Button
DIM NextAnnee AS Button
DIM x1 AS INTEGER
DIM y1 AS INTEGER
DIM x2 AS INTEGER
DIM y2 AS INTEGER
TableauMois(1) = "Janvier"
TableauMois(2) = "Fevrier"
TableauMois(3) = "Mars"
TableauMois(4) = "Avril"
TableauMois(5) = "Mai"
TableauMois(6) = "Juin"
TableauMois(7) = "Juillet"
TableauMois(8) = "Aot"
TableauMois(9) = "Septembre"
TableauMois(10) = "Octobre"
TableauMois(11) = "Novembre"
TableauMois(12) = "Decembre"
TableauJour(7) = "Di"
TableauJour(1) = "lu"
TableauJour(2) = "ma"
TableauJour(3) = "me"
TableauJour(4) = "je"
TableauJour(5) = "ve"
TableauJour(6) = "sa"

jour = VAL(MID$(DATE$, 4, 2))
mois = VAL(LEFT$(DATE$, 2))
annee = VAL(RIGHT$(DATE$, 4))
cjour = jour
cmois = mois
cannee = annee
xl = 190
yl = 115
x1 = (320 - xl) / 2
y1 = (210 - yl) / 2
x2 = x1 + xl
y2 = y1 + yl


Create.Button PrevMois, x1 + 5, y1 - 20, x1 + 35, y1 - 9, "<"
Create.Button NextMois, x2 - 35, y1 - 20, x2 - 5, y1 - 9, ">"
Create.Button PrevAnnee, x1 + 5, y2 + 9, x1 + 35, y2 + 20, "<"
Create.Button NextAnnee, x2 - 35, y2 + 9, x2 - 5, y2 + 20, ">"

App.SetTitle "Calendrier"
Add.MenuItem "Quiter"
load.font sharedpath + "\fonte.bin"
SCREEN 13
cls.screen bgcolor
IF bgimage <> "" THEN load.bsv bgrdpath + "\" + LEFT$(bgimage, LEN(bgimage) - 4) + ".bsv"', 0, 0, 1
Draw.AppButtons
Draw.Button PrevMois
Draw.Button NextMois
Draw.Button PrevAnnee
Draw.Button NextAnnee

GOSUB DrawCalendar
MouseShow

DO
	Manage.APP
	Manage.Button PrevMois
	Manage.Button NextMois
	Manage.Button PrevAnnee
	Manage.Button NextAnnee
	
	IF NextAnnee.cliqued THEN
		annee = annee + 1
		IF annee = 0 THEN annee = 1
		GOSUB DrawCalendar
	END IF
	IF PrevAnnee.cliqued THEN
		annee = annee - 1
		IF annee = 0 THEN annee = -1
		GOSUB DrawCalendar
	END IF

	IF NextMois.cliqued THEN
		mois = (mois MOD 12) + 1
		IF mois = 1 THEN annee = annee + 1
		IF annee = 0 THEN annee = 1
		GOSUB DrawCalendar
	END IF
	IF PrevMois.cliqued THEN
		mois = mois - 1
		IF mois = 0 THEN
			mois = 12
			annee = annee - 1
			IF mois = 0 THEN mois = -1
			IF annee = 0 THEN annee = -1
		END IF
		GOSUB DrawCalendar
	END IF

	MenuSelection = GetMenuSelected$
LOOP UNTIL MenuSelection = "Quiter"
EndApp
						     





DIM i AS INTEGER
DrawCalendar:
FOR i = 1 TO nbrjours(mois, annee)
	x = JourSemaine(i, mois, annee)
	y = INT((i - 1) / 7) + ABS(JourSemaine(i, mois, annee) < JourSemaine(1, mois, annee))
	Create.Button BtnJours(i), x1 + 10 + ((x - 1) * 25), y1 + 20 + (y * 15), x1 + 32 + ((x - 1) * 25), y1 + 32 + (y * 15), STR$(i)
NEXT i

MouseHide
Draw.frame x1, y1, x2, y2, 3
LINE (x1 + 159, y1 + 5)-(x1 + 183, y2 - 5), 1, BF
LINE (x1 + 134, y1 + 5)-(x1 + 158, y2 - 5), 9, BF

FOR i = 1 TO nbrjours(mois, annee)
	x = JourSemaine(i, mois, annee)
	y = INT((i - 1) / 7) + ABS(JourSemaine(i, mois, annee) < JourSemaine(1, mois, annee))
	IF i = cjour AND mois = cmois AND annee = cannee THEN
	LINE (x1 + 9 + ((x - 1) * 25), y1 + 19 + (y * 15))-(x1 + 33 + ((x - 1) * 25), y1 + 33 + (y * 15)), 10, BF
	END IF
	Draw.Button BtnJours(i)
NEXT i
FOR i = 1 TO 7
      Draw.texte TableauJour(i), x1 + 15 + ((i - 1) * 25), y1 + 10, 0, -1
NEXT i

Draw.frame x1 + 40, y1 - 25, x2 - 40, y1 - 5, 3
Draw.texte TableauMois(mois), x1 + 60, y1 - 19, 0, 15
Draw.frame x1 + 40, y2 + 5, x2 - 40, y2 + 25, 3
Draw.texte STR$(annee), x1 + 70, y2 + 11, 0, 15

MouseShow
RETURN

FUNCTION JourSemaine (jour AS INTEGER, mois AS INTEGER, annee AS INTEGER)
'JourSemaine = Mark.Dettinger(jour, mois, annee)
JourSemaine = Mike.Keith(jour, mois, annee)
END FUNCTION

FUNCTION Mark.Dettinger (jour AS INTEGER, mois AS INTEGER, annee AS INTEGER)
DIM TabMont(0 TO 1, 1 TO 12)

TabMont(1, 1) = 1
TabMont(1, 2) = 4
TabMont(1, 3) = 4
TabMont(1, 4) = 0
TabMont(1, 5) = 2
TabMont(1, 6) = 5
TabMont(1, 7) = 0
TabMont(1, 8) = 3
TabMont(1, 9) = 6
TabMont(1, 10) = 1
TabMont(1, 11) = 4
TabMont(1, 12) = 6
TabMont(0, 1) = 0
TabMont(0, 2) = 3
TabMont(0, 3) = 4
TabMont(0, 4) = 0
TabMont(0, 5) = 2
TabMont(0, 6) = 5
TabMont(0, 7) = 0
TabMont(0, 8) = 3
TabMont(0, 9) = 6
TabMont(0, 10) = 1
TabMont(0, 11) = 4
TabMont(0, 12) = 6

'algorythme: x=(c+y+m+d) mod 7
'c= sicle (ex 20 pour 1995) a partir de l'an 0
'y =annes sur 2 chiffres (ex 95 pour 1995)
'm = code numerique du mois (voir tableau)
c = INT(mois / 100) + 1
yb = annee - ((c - 1) * 100)
y = (yb + INT(yb / 4)) MOD 7
'si c'est une anne bisexstile on va voir dans tabmont(0,x) sinon dans tabmont(1,x)
m = TabMont(ABS(nbrjours(2, annee) = 28), mois)
d = jour + 3
x = ((c + y + m + d) MOD 7)
'x = x + 3
'IF x > 7 THEN x = x - 7

IF x = 0 THEN x = 7
Mark.Dettinger = x
END FUNCTION

FUNCTION Mike.Keith (jour AS INTEGER, mois AS INTEGER, annee AS INTEGER)
DIM y AS INTEGER
DIM m AS INTEGER
DIM d AS INTEGER
DIM z AS INTEGER
DIM ds AS INTEGER
y = annee
IF y < 0 THEN y = y + 1
m = mois
d = jour
IF m < 3 THEN z = y - 1
IF m >= 3 THEN z = y
ds = (INT((23 * m) / 9) + d + 4 + y + INT(z / 4) - INT(z / 100) + INT(z / 400) + 2 * (m >= 3)) MOD 7
IF ds = 0 THEN ds = 7
Mike.Keith = ds
END FUNCTION

FUNCTION nbrjours (mois AS INTEGER, annee AS INTEGER)
 a = 0
 a = a + ABS(((mois MOD 2) = 0) * (((mois < 8) * 30) + ((mois > 7) * 31)))
 a = a + ABS(((mois MOD 2) > 0) * (((mois < 8) * 31) + ((mois > 7) * 30)))
 a = ABS((mois <> 2) * a) + ((mois = 2) * ((((annee MOD 4) > 0) * 28) + (((annee MOD 400) = 0) * 29) + (((annee MOD 100) = 0) AND ((annee MOD 400) > 0) * 28) + (((annee MOD 4) = 0) AND ((annee MOD 100) > 0) * 29)))
 nbrjours = a
END FUNCTION

