DECLARE SUB File.open (fichier$)
DECLARE SUB File.save (fichier$)
DECLARE SUB File.new ()
DECLARE SUB draw.pixel (x AS INTEGER, y AS INTEGER)
DECLARE SUB draw.palette ()
'$INCLUDE: 'includes\guilib.bi'
'$INCLUDE: 'includes\session.bi'

DIM SHARED Icone(0 TO 14, 0 TO 14) AS STRING * 1
DIM SHARED SelColor AS INTEGER
DIM SHARED Filename AS STRING
DIM x AS INTEGER
DIM y AS INTEGER
DIM OpenBtn AS Button
DIM SaveBtn AS Button
DIM MyTxtBox AS TextBox
App.SetTitle "Picture 256"
Add.MenuItem "Nouveau"
Add.MenuItem "Quiter"
Create.Button OpenBtn, 32, 155, 157, 170, "Ouvrir"
Create.Button SaveBtn, 162, 155, 277, 170, "Sauver"
Create.TextBox MyTxtBox, 102, 175, 277, 190, "", ""

load.font sharedpath + "\fonte.bin"
SCREEN 13
cls.screen bgcolor
IF bgimage <> "" THEN load.bsv bgrdpath + "\" + LEFT$(bgimage, LEN(bgimage) - 4) + ".bsv"', 0, 0, 1
Draw.AppButtons
Draw.frame 110, 25, 225, 140, 2
Draw.frame 245, 25, 270, 50, 2
Draw.frame 27, 150, 282, 195, 2
Draw.texte "Fichier :", 32, 178, 0, 15
Draw.Button OpenBtn
Draw.Button SaveBtn
Draw.TextBox MyTxtBox
File.new
draw.palette
MouseShow

DO
Manage.APP
Manage.Button OpenBtn
Manage.Button SaveBtn
Manage.TextBox MyTxtBox
MenuSelection = GetMenuSelected$
IF NewBtn.Cliqued OR MenuSelection = "Nouveau" THEN
	File.new
	MyTxtBox.Texte = ""
	MyTxtBox.TextLen = 0
	Draw.TextBox MyTxtBox
END IF
IF OpenBtn.cliqued THEN File.open RTRIM$(LTRIM$(MyTxtBox.Texte))
IF SaveBtn.cliqued THEN File.save RTRIM$(LTRIM$(MyTxtBox.Texte))
	IF MouseClicLeft THEN
		IF MouseZOne(5, 25, 95, 130) THEN
			FOR I = 0 TO 255
				x = I MOD 16
				y = INT(I / 16)
				IF MouseZOne(10 + (x * 5), 30 + (y * 5), 15 + (x * 5), 35 + (y * 5)) THEN
					SelColor = I
					MouseHide
					LINE (10, 114)-(90, 125), SelColor, BF
					LINE (10, 114)-(90, 125), 0, B
					MouseShow
				END IF
			NEXT I
		END IF
		IF MouseZOne(110, 25, 225, 140) THEN
			FOR xa% = 0 TO 14
			FOR ya% = 0 TO 14
			IF MouseZOne(115 + (xa% * 7), 30 + (ya% * 7), 122 + (xa% * 7), 37 + (ya% * 7)) THEN
				Icone(xa%, ya%) = CHR$(SelColor)
				MouseHide
				draw.pixel xa%, ya%
				MouseShow
			END IF
			NEXT ya%
			NEXT xa%
		END IF
	END IF
LOOP UNTIL MenuSelection = "Quiter"
EndApp

SUB draw.palette
Draw.frame 5, 25, 95, 130, 2
MouseHide
FOR I = 0 TO 255
	x = I MOD 16
	y = INT(I / 16)
	LINE (10 + (x * 5), 30 + (y * 5))-(15 + (x * 5), 35 + (y * 5)), I, BF
	LINE (10, 114)-(90, 125), SelColor, BF
	LINE (10, 114)-(90, 125), 0, B
NEXT I
MouseShow
END SUB

SUB draw.pixel (x AS INTEGER, y AS INTEGER)
	IF Icone(x, y) = CHR$(255) THEN
		LINE (115 + (x * 7), 30 + (y * 7))-(122 + (x * 7), 37 + (y * 7)), 15, BF
		LINE (115 + (x * 7), 30 + (y * 7))-(122 + (x * 7), 37 + (y * 7)), 0
		PSET (250 + x, 30 + y), 15
	ELSE
		LINE (115 + (x * 7), 30 + (y * 7))-(122 + (x * 7), 37 + (y * 7)), ASC(Icone(x, y)), BF
		PSET (250 + x, 30 + y), ASC(Icone(x, y))
	END IF
	LINE (115 + (x * 7), 30 + (y * 7))-(122 + (x * 7), 37 + (y * 7)), 0, B


END SUB

SUB File.new
DIM x AS INTEGER
DIM y AS INTEGER
FOR x = 0 TO 14
	FOR y = 0 TO 14
		Icone(x, y) = CHR$(255)
		draw.pixel x, y
	NEXT y
NEXT x
SelColor = 1
Filename = ""
END SUB

SUB File.open (fichier$)
IF fichier$ <> "" THEN 'AND FileExist(fichier$) THEN
MouseHide
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM x AS INTEGER
DIM y AS INTEGER
xs = 0
ys = 0

	fic = FREEFILE
	OPEN fichier$ FOR BINARY AS fic
		GET #fic, , xs
		GET #fic, , ys
		IF xs > 15 THEN xs = 15
		IF ys > 15 THEN ys = 15
		FOR y = ys - 1 TO 0 STEP -1
		 FOR x = xs - 1 TO 0 STEP -1
		  GET #fic, , Icone(x, y)
		  draw.pixel x, y
		 NEXT x
		NEXT y
	CLOSE fic
END IF
MouseShow
END SUB

SUB File.save (fichier$)
IF fichier$ <> "" THEN
fic = FREEFILE
DIM xs AS INTEGER
DIM ys AS INTEGER
xs = 15
ys = 15
	OPEN fichier$ FOR BINARY AS fic
		PUT #fic, , xs
		PUT #fic, , ys
		FOR y = 14 TO 0 STEP -1
		 FOR x = 14 TO 0 STEP -1
			PUT #fic, , Icone(x, y)
		 NEXT x
		NEXT y
	CLOSE fic
END IF
END SUB

