DECLARE SUB saveLabel (Destination AS STRING, Source AS STRING, longueur AS INTEGER)
DECLARE SUB RestoreLabel (Source AS STRING, Destination AS STRING)
'$INCLUDE: 'includes\guilib.bi'
TYPE Contact
	nom AS STRING * 30
	Prenom AS STRING * 30
	Adress AS STRING * 50
	Numero AS STRING * 4
	CodePostal AS STRING * 8
	Localite AS STRING * 50
	Pays AS STRING * 50
	Email AS STRING * 50
	Telephone AS STRING * 30
END TYPE
CONST maxcontact = 50
DIM ListeContact(1 TO maxcontact) AS Contact
DIM CurrentView AS INTEGER
DIM NbrContact AS INTEGER
DIM LabelNom AS TextBox
DIM LabelPrenom AS TextBox
DIM LabelAdress AS TextBox
DIM LabelNum AS TextBox
DIM LabelCP  AS TextBox
DIM LabelLoc AS TextBox
DIM LabelPays AS TextBox
DIM LabelTel AS TextBox
DIM LabelEmail AS TextBox
DIM AddBtn AS Button
DIM DelBtn AS Button
DIM NextBtn AS Button
DIM PrevBtn AS Button
'$INCLUDE: 'includes\session.bi'
NbrContacts = 0
CurrentView = 0
App.SetTitle "Contact Manager"
Add.MenuItem "Sauver"
Add.MenuItem "Quiter"
Create.TextBox LabelPrenom, 80, 30, 160, 45, "", ""
Create.TextBox LabelNom, 210, 30, 304, 45, "", ""
Create.TextBox LabelAdress, 80, 50, 200, 65, "", ""
Create.TextBox LabelNum, 240, 50, 304, 65, "", ""
Create.TextBox LabelCP, 80, 70, 140, 85, "", ""
Create.TextBox LabelLoc, 210, 70, 304, 85, "", ""
Create.TextBox LabelPays, 80, 90, 304, 105, "", ""
Create.TextBox LabelTel, 80, 110, 304, 125, "", ""
Create.TextBox LabelEmail, 80, 130, 304, 145, "", ""

Create.Button DelBtn, 85, 165, 105, 185, "-"
Create.Button AddBtn, 214, 165, 234, 185, "+"
Create.Button PrevBtn, 110, 165, 130, 185, "<"
Create.Button NextBtn, 189, 165, 209, 185, ">"
load.font sharedpath + "\fonte.bin"
SCREEN 13
cls.screen bgcolor
IF bgimage <> "" THEN load.bsv bgrdpath + "\" + LEFT$(bgimage, LEN(bgimage) - 4) + ".bsv"', 0, 0, 1
Draw.AppButtons
Draw.frame 10, 25, 309, 150, 3
Draw.frame 80, 160, 239, 190, 3
Draw.texte "Prnom :            Nom:", 15, 33, 0, 15
Draw.texte "Adresse:                Num:", 15, 53, 0, 15
Draw.texte "Num CP :          Ville:", 15, 73, 0, 15
Draw.texte "Pays   :", 15, 93, 0, 15
Draw.texte "Tel    :", 15, 113, 0, 15
Draw.texte "E-Mail :", 15, 133, 0, 15
affiche$ = LTRIM$(RTRIM$(STR$(CurrentView))) + "/" + LTRIM$(RTRIM$(STR$(NbrContacts)))
Draw.texte affiche$, 160 - (LEN(affiche$) * 4), 170, 0, 15

Draw.TextBox LabelNom
Draw.TextBox LabelPrenom
Draw.TextBox LabelAdress
Draw.TextBox LabelNum
Draw.TextBox LabelCP
Draw.TextBox LabelLoc
Draw.TextBox LabelPays
Draw.TextBox LabelTel
Draw.TextBox LabelEmail

Draw.Button DelBtn
Draw.Button AddBtn
Draw.Button PrevBtn
Draw.Button NextBtn

MouseShow
NbrContact = 0
fic = FREEFILE
OPEN datapath + "\Contact.dat" FOR BINARY AS fic
GET #fic, , NbrContact
	FOR i = 1 TO NbrContact
		GET #fic, , ListeContact(i)
	NEXT i
CLOSE fic

CurrentView = NbrContact
GOSUB restoreview
DO
Manage.APP
Manage.TextBox LabelNom
Manage.TextBox LabelPrenom
Manage.TextBox LabelAdress
Manage.TextBox LabelNum
Manage.TextBox LabelCP
Manage.TextBox LabelLoc
Manage.TextBox LabelPays
Manage.TextBox LabelTel
Manage.TextBox LabelEmail
Manage.Button DelBtn
Manage.Button AddBtn
Manage.Button PrevBtn
Manage.Button NextBtn
MenuSelection = GetMenuSelected$
IF NextBtn.cliqued AND NbrContact > 0 THEN
	GOSUB SaveView
	CurrentView = CurrentView + 1
	IF CurrentView > NbrContact THEN CurrentView = 1
	GOSUB restoreview
END IF
IF PrevBtn.cliqued AND NbrContact > 0 THEN
	GOSUB SaveView
	CurrentView = CurrentView - 1
	IF CurrentView < 1 THEN CurrentView = NbrContact
	GOSUB restoreview
END IF

IF AddBtn.cliqued AND (NbrContact < maxcontact) THEN
	NbrContact = NbrContact + 1
	GOSUB SaveView
	CurrentView = NbrContact
	ListeContact(CurrentView).nom = ""
	ListeContact(CurrentView).Prenom = ""
	ListeContact(CurrentView).Adress = ""
	ListeContact(CurrentView).Numero = ""
	ListeContact(CurrentView).CodePostal = ""
	ListeContact(CurrentView).Localite = ""
	ListeContact(CurrentView).Pays = ""
	ListeContact(CurrentView).Email = ""
	ListeContact(CurrentView).Telephone = ""
	GOSUB restoreview
END IF

IF DelBtn.cliqued AND NbrContact > 0 THEN
      FOR i = CurrentView TO NbrContact - 1
		ListeContact(i) = ListeContact(i + 1)
      NEXT
      NbrContact = NbrContact - 1
      IF NbrContact = 0 THEN CurrentView = 0
      IF CurrentView > NbrContact THEN CurrentView = NbrContact
      GOSUB restoreview
END IF
IF MenuSelection = "Sauver" THEN
	GOSUB SaveView
	GOSUB SaveFile
END IF
LOOP UNTIL MenuSelection = "Quiter"
GOSUB SaveView

EndApp

SaveView:
	IF CurrentView > 0 THEN
		saveLabel ListeContact(CurrentView).nom, LabelNom.Texte, 30
		saveLabel ListeContact(CurrentView).Prenom, LabelPrenom.Texte, 30
		saveLabel ListeContact(CurrentView).Adress, LabelAdress.Texte, 50
		saveLabel ListeContact(CurrentView).Numero, LabelNum.Texte, 4
		saveLabel ListeContact(CurrentView).CodePostal, LabelCP.Texte, 8
		saveLabel ListeContact(CurrentView).Localite, LabelLoc.Texte, 50
		saveLabel ListeContact(CurrentView).Pays, LabelPays.Texte, 50
		saveLabel ListeContact(CurrentView).Email, LabelEmail.Texte, 50
		saveLabel ListeContact(CurrentView).Telephone, LabelTel.Texte, 30
		
	END IF
RETURN

restoreview:
	IF CurrentView > 0 THEN
		LabelNom.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).nom))
		LabelPrenom.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Prenom))
		LabelAdress.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Adress))
		LabelNum.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Numero))
		LabelCP.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).CodePostal))
		LabelLoc.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Localite))
		LabelPays.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Pays))
		LabelEmail.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Email))
		LabelTel.Texte = LTRIM$(RTRIM$(ListeContact(CurrentView).Telephone))

		LabelNom.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).nom)))
		LabelPrenom.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Prenom)))
		LabelAdress.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Adress)))
		LabelNum.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Numero)))
		LabelCP.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).CodePostal)))
		LabelLoc.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Localite)))
		LabelPays.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Pays)))
		LabelEmail.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Email)))
		LabelTel.TextLen = LEN(LTRIM$(RTRIM$(ListeContact(CurrentView).Telephone)))
	ELSE
		LabelNom.Texte = ""
		LabelPrenom.Texte = ""
		LabelAdress.Texte = ""
		LabelNum.Texte = ""
		LabelCP.Texte = ""
		LabelLoc.Texte = ""
		LabelPays.Texte = ""
		LabelEmail.Texte = ""
		LabelTel.Texte = ""

		LabelNom.TextLen = 0
		LabelPrenom.TextLen = 0
		LabelAdress.TextLen = 0
		LabelNum.TextLen = 0
		LabelCP.TextLen = 0
		LabelLoc.TextLen = 0
		LabelPays.TextLen = 0
		LabelEmail.TextLen = 0
		LabelTel.TextLen = 0

	END IF
Draw.TextBox LabelNom
Draw.TextBox LabelPrenom
Draw.TextBox LabelAdress
Draw.TextBox LabelNum
Draw.TextBox LabelCP
Draw.TextBox LabelLoc
Draw.TextBox LabelPays
Draw.TextBox LabelTel
Draw.TextBox LabelEmail
LINE (131, 164)-(188, 186), 15, BF
affiche$ = LTRIM$(RTRIM$(STR$(CurrentView))) + "/" + LTRIM$(RTRIM$(STR$(NbrContact)))
Draw.texte affiche$, 160 - (LEN(affiche$) * 4), 171, 0, 15

RETURN

SaveFile:
fic = FREEFILE
OPEN datapath + "\Contact.dat" FOR BINARY AS fic
PUT #fic, , NbrContact
	FOR i = 1 TO NbrContact
		PUT #fic, , ListeContact(i)
	NEXT i
CLOSE fic
RETURN

SUB saveLabel (Destination AS STRING, Source AS STRING, longueur AS INTEGER)
		Destination = LEFT$(LTRIM$(RTRIM$(Source)), longueur)
END SUB

