'$INCLUDE: 'includes\guilib.bi'
DIM SHARED fontdata(0 TO 255, 0 TO 7) AS STRING * 1
DIM SHARED Icondata(900)
DIM SHARED regs AS RegType
DIM SHARED MenuButton AS Button
DIM SHARED ExitButton AS Button
DIM SHARED MenuItem(1 TO 10) AS STRING * 25
DIM SHARED MenuData(4483)
DIM SHARED NbrMenuItem AS INTEGER
DIM SHARED MenuFocus AS INTEGER
DIM SHARED MenuSelect AS INTEGER
DIM SHARED MenuSelected AS INTEGER
DIM SHARED MenuX1 AS INTEGER
DIM SHARED MenuY1 AS INTEGER
DIM SHARED MenuX2 AS INTEGER
DIM SHARED MenuY2 AS INTEGER
DIM SHARED LockIcon AS INTEGER

SUB Add.MenuItem (nom AS STRING)
	IF NbrMenuItem < 10 THEN
		NbrMenuItem = NbrMenuItem + 1
		MenuItem(NbrMenuItem) = nom
		MenuX1 = 0
		MenuY1 = 16
		MaxLen = 0
		FOR i = 1 TO NbrMenuItem
			IF LEN(LTRIM$(RTRIM$(MenuItem(i)))) > MaxLen THEN
				MaxLen = LEN(LTRIM$(RTRIM$(MenuItem(i))))
			END IF
		NEXT i
		MenuX2 = MenuX1 + (MaxLen * 8) + 10
		MenuY2 = MenuY1 + (NbrMenuItem * 12) + 4
	END IF
END SUB

SUB app.setlogin
	app.root = 2
END SUB

SUB APP.SetRoot
	app.root = 1
END SUB

SUB App.SetTitle (nom AS STRING)
	app.root = 0
	Create.Button MenuButton, 0, 0, LEN(nom) * 8 + 4, 15, nom
	Create.Button ExitButton, 300, 0, 319, 15, "X"
END SUB

SUB cls.screen (col AS INTEGER)
	LINE (0, 0)-(319, 199), col, BF
END SUB

SUB Create.Button (Button AS Button, x1, y1, x2, y2, Texte AS STRING)
	Button.x1 = x1
	Button.x2 = x2
	Button.y1 = y1
	Button.y2 = y2
	Button.text = Texte
	Button.pressed = 0
	Button.cliqued = 0
END SUB

SUB Create.CheckBox (CheckBox AS CheckBox, cx AS INTEGER, cy AS INTEGER, state AS INTEGER)
	CheckBox.cx = cx
	CheckBox.cy = cy
	CheckBox.Selected = state AND 1
END SUB

SUB Create.icone (Icone AS Icone, iconfile AS STRING, x AS INTEGER, y AS INTEGER, nom AS STRING)
	Icone.Fichier = iconfile
	Icone.x = x
	Icone.y = y
	Icone.focused = 0
	Icone.cliqued = 0
	Icone.nom = nom
END SUB

SUB Create.TextBox (TextBox AS TextBox, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, initialtext AS STRING, Masque AS STRING)
	TextBox.x1 = x1
	TextBox.x2 = x2
	TextBox.y1 = y1
	TextBox.y2 = y2
	TextBox.Texte = LTRIM$(RTRIM$(initialtext))
	TextBox.focused = 0
	TextBox.TextLen = LEN(LTRIM$(RTRIM$(initialtext)))
	TextBox.Masque = Masque
END SUB

SUB Draw.AppButtons
	Draw.relief ((LEN(LTRIM$(RTRIM$(MenuButton.text))) * 8) + 5), 0, 299, 15, 23
	Draw.Button MenuButton
	Draw.Button ExitButton
END SUB

SUB Draw.Button (Button AS Button)
Texte$ = LTRIM$(RTRIM$(Button.text$))
IF (Button.x2 - Button.x1 - 4) < LEN(Texte$) * 8 THEN
	Texte$ = LEFT$(Texte$, (Button.x2 - Button.x1 - 4) / 8)
END IF

MouseHide
IF Button.pressed THEN
	Draw.unrelief Button.x1, Button.y1, Button.x2, Button.y2, 23
ELSE
	Draw.relief Button.x1, Button.y1, Button.x2, Button.y2, 23
END IF
Draw.texte Texte$, (Button.x2 + Button.x1 - (LEN(Texte$) * 8)) / 2, INT((Button.y2 + Button.y1 - 8) / 2) + 2, 15, -1
MouseShow

END SUB

SUB Draw.CheckBox (CheckBox AS CheckBox)
MouseHide
	LINE (CheckBox.cx - 5, CheckBox.cy - 5)-(CheckBox.cx + 5, CheckBox.cy + 5), 15, BF
	LINE (CheckBox.cx - 5, CheckBox.cy - 5)-(CheckBox.cx + 5, CheckBox.cy + 5), 7, B
	IF CheckBox.Selected THEN LINE (CheckBox.cx - 3, CheckBox.cy - 3)-(CheckBox.cx + 3, CheckBox.cy + 3), 7, BF
MouseShow
END SUB

SUB Draw.frame (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, epaisseur AS INTEGER)
MouseHide
	LINE (x1, y1)-(x2, y2), 31, BF
	LINE (x1, y1)-(x2, y2), 0, B

	FOR i = 0 TO 10
		LINE (x1 + 1, y1 + 1 + i)-(x2 - 1, y1 + 1 + i), 21 + i
		LINE (x1 + 1, y2 - 1 - i)-(x2 - 1, y2 - 1 - i), 21 + i
	NEXT i

	LINE (x1 + epaisseur, y1 + epaisseur)-(x2 - epaisseur, y2 - epaisseur), 15, BF
	LINE (x1 + epaisseur, y1 + epaisseur)-(x2 - epaisseur, y2 - epaisseur), 0, B
MouseShow
END SUB

SUB Draw.Icone (Icone AS Icone)
MouseHide
	IF Icone.focused THEN
		Draw.Pic Icone.Fichier, Icone.x - 30, Icone.y - 30, 4
		Draw.relief 0, 185, 319, 219, 23
		Draw.texte LTRIM$(RTRIM$(Icone.nom)), 5, 189, 15, 23
	ELSE
		Draw.Pic Icone.Fichier, Icone.x - 7, Icone.y - 7, 1
		Draw.relief 0, 185, 319, 219, 23
	END IF
MouseShow
END SUB

SUB Draw.Menu

	Draw.relief MenuX1, MenuY1, MenuX2, MenuY2, 23
	FOR i = 1 TO NbrMenuItem
		Draw.texte (LTRIM$(RTRIM$(MenuItem(i)))), MenuX1 + 5, MenuY1 + 5 + ((i - 1) * 12), 15, 23
	NEXT i
END SUB

SUB Draw.Pic (picfile AS STRING, x1 AS INTEGER, y1 AS INTEGER, z1 AS SINGLE)
IF LTRIM$(RTRIM$(picfile)) = "" THEN EXIT SUB
DEF SEG = &HA000
MouseHide
fic = FREEFILE
DIM rat AS INTEGER
ratio = z1
IF ratio = 0 THEN ratio = 1
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM zs AS STRING * 1
	OPEN picfile FOR BINARY AS fic
		GET #fic, , xs
		GET #fic, , ys
		  FOR y = ys - 1 TO 0 STEP -1
			FOR x = xs - 1 TO 0 STEP -1
		       
				GET #fic, , zs
				'pour des images grossies
				IF ratio >= 1 THEN
				FOR x2 = 1 TO ratio
					FOR y2 = 1 TO ratio
						IF ASC(zs) <> 255 THEN
						POKE ((y1 + (y * ratio) + y2 - 1) * 320) + (x1 + (x * ratio) + x2 - 1), ASC(zs)
						END IF
					NEXT y2
				NEXT x2
				ELSE
					rat = (rat + 1) MOD (1 / ratio)
					IF rat = 0 THEN PSET (x1 + INT(x * ratio), y1 + INT(y * ratio)), ASC(zs)
				END IF
			NEXT x
		NEXT y
CLOSE fic
MouseShow
DEF SEG
END SUB

SUB Draw.Pic2 (imgfile AS STRING, cx1 AS INTEGER, cy1 AS INTEGER, cx2 AS INTEGER, cy2 AS INTEGER, x1 AS INTEGER, y1 AS INTEGER)
MouseHide
fic = FREEFILE
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM zs AS STRING * 1
	OPEN imgfile FOR BINARY AS fic
		GET #fic, , xs
		GET #fic, , ys
		FOR y = cy2 TO cy1 STEP -1
		 SEEK #fic, ((199 - y) * xs) + ((319) - cx2) + 5
			FOR x = cx2 TO cx1 STEP -1
				GET #fic, , zs
				PSET (x1 + x - cx1, y1 + y - cy1), ASC(zs)
			NEXT x
		NEXT y
	CLOSE fic
MouseShow

END SUB

SUB Draw.relief (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, basecol AS INTEGER)
MouseHide
IF basecol < 19 THEN basecol = 19
IF basecol > 28 THEN basecol = 28
	LINE (x1, y1)-(x2, y2), basecol, BF
	LINE (x1, y2)-(x1, y1), basecol + 2
	LINE -(x2, y1), basecol + 2
	LINE -(x2, y2), basecol - 2
	LINE -(x1, y2), basecol - 2
MouseShow
END SUB

SUB Draw.TextBox (TextBox AS TextBox)
	MouseHide
	LINE (TextBox.x1, TextBox.y1)-(TextBox.x2, TextBox.y2), 15, BF
	LINE (TextBox.x1, TextBox.y1)-(TextBox.x2, TextBox.y2), ABS(TextBox.focused = -1) * 7 + ABS(TextBox.focused = 0) * 8, B
	MaxLen = (TextBox.x2 - TextBox.x1 - 10) / 8
	todisplay$ = LEFT$(TextBox.Texte, TextBox.TextLen)
	IF LEN(LTRIM$(RTRIM$(TextBox.Masque))) > 0 THEN todisplay$ = STRING$(LEN(todisplay$), TextBox.Masque)
	IF TextBox.focused = -1 THEN todisplay$ = todisplay$ + "_"
	IF LEN(todisplay$) > MaxLen THEN todisplay$ = RIGHT$(todisplay$, MaxLen)
	Draw.texte todisplay$, TextBox.x1 + 5, 1 + ((TextBox.y2 + TextBox.y1 - 8) / 2), ABS(TextBox.focused = -1) * 8 + ABS(TextBox.focused = 0) * 7, 15
	MouseShow
END SUB

SUB Draw.texte (Texte AS STRING, x1 AS INTEGER, y1 AS INTEGER, fcolor AS INTEGER, bcolor AS INTEGER)
MouseHide
	FOR i = 1 TO LEN(Texte)
	      a = ASC(MID$(Texte, i, 1))
	     FOR y = 0 TO 7
		FOR x = 0 TO 7
		   IF (ASC(fontdata(a, y)) AND (2 ^ (7 - x))) = (2 ^ (7 - x)) THEN
			PSET (x1 + x, y1 + y), fcolor
		   ELSE
			IF bcolor <> -1 THEN PSET (x1 + x, y1 + y), bcolor
		   END IF
		NEXT x
	       
	     NEXT y
	      x1 = x1 + 8
	NEXT i
MouseShow
END SUB

SUB Draw.unrelief (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, basecol AS INTEGER)
MouseHide
IF basecol < 19 THEN basecol = 19
IF basecol > 28 THEN basecol = 28
	LINE (x1, y1)-(x2, y2), basecol, BF
	LINE (x1, y2)-(x1, y1), basecol - 2
	LINE -(x2, y1), basecol - 2
	LINE -(x2, y2), basecol + 2
	LINE -(x1, y2), basecol + 2
MouseShow
END SUB

SUB EndApp
	SELECT CASE app.root
	CASE 1
		setvar "system.ini", "cclkey", "logged"
		CHAIN getvar$("system.ini", "binpath") + "\login.exe"
	CASE 2
		SCREEN 0
		WIDTH 80, 25
		SYSTEM
	CASE ELSE
		CHAIN getvar$("system.ini", "binpath") + "\desktop.exe"
	END SELECT
END SUB

FUNCTION GetMenuSelected$
	IF MenuSelected = 0 THEN
		GetMenuSelected$ = ""
	ELSE
		GetMenuSelected$ = LTRIM$(RTRIM$(MenuItem(MenuSelected)))
		MenuSelected = 0
	END IF
END FUNCTION

FUNCTION getvar$ (inifile AS STRING, nomdevariable AS STRING)
	 fic = FREEFILE
	 DIM chaine AS STRING
	 OPEN inifile FOR INPUT AS fic
	 DO UNTIL EOF(fic)
	    INPUT #fic, chaine
	    chaine = LTRIM$(RTRIM$(chaine))
	    'si c'est un commentaire, on l'ignore
	    IF LEFT$(chaine, 1) <> "#" THEN

		'on supprime les commentaires dans la ligne
		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "#" THEN
				chaine = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				EXIT FOR
			END IF
		NEXT i
		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "=" THEN
				variable$ = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				IF variable$ = nomdevariable THEN
				valeur$ = LTRIM$(RTRIM$(MID$(chaine, i + 1)))
				'on cherche d'eventuelles combinaisons
				debut = 1
debutb:
				FOR j = debut TO LEN(valeur$)
					IF MID$(valeur$, j, 1) = "%" THEN
					      FOR k = j + 1 TO LEN(valeur$)
						       IF MID$(valeur$, k, 1) = "%" THEN
						       dd$ = MID$(valeur$, j + 1, k - j - 1)
						       valeur$ = LEFT$(valeur$, j - 1) + getvar$(inifile, dd$) + MID$(valeur$, k + 1)
							GOTO debutb
						      
						       END IF
					      NEXT k
					      valeur$ = ""
					      GOTO suiteb
					END IF
				NEXT j
			       
suiteb:
				IF LCASE$(nomdevariable) = LCASE$(variable$) THEN
					retval$ = valeur$
					GOTO suite
				END IF
				END IF
			END IF
		NEXT i
	    END IF
	 LOOP
	 retval$ = ""
suite:
CLOSE fic
getvar$ = LTRIM$(RTRIM$(retval$))
END FUNCTION

SUB Load.BMP (bmpfile AS STRING, x1 AS INTEGER, y1 AS INTEGER)
       DIM BmpHeader AS BMPHeaderType
       fic = FREEFILE
       OPEN bmpfile FOR BINARY AS #fic
       GET #fic, , BmpHeader

	DIM Pixel AS STRING * 1
	iHeight% = BmpHeader.hei
	iWidth% = BmpHeader.wid
	FOR y% = iHeight% - 1 TO 0 STEP -1
		FOR x% = iWidth% - 1 TO 0 STEP -1
			GET #fic, , Pixel
			PSET (x1 + x% - 1, y1 + y% - 1), ASC(Pixel)
		NEXT x%
	NEXT y%
	CLOSE fic
END SUB

SUB load.bsv (image AS STRING)
	DEF SEG = &HA000
	BLOAD image
	DEF SEG
END SUB

SUB load.font (fontfile AS STRING)
fic = FREEFILE
OPEN fontfile FOR BINARY AS fic
FOR i = 0 TO 255
	FOR y = 0 TO 7
		GET #fic, , fontdata(i, y)
	NEXT y
NEXT i
CLOSE fic
END SUB

SUB Manage.APP
	Manage.Button ExitButton
	Manage.Menu
	IF ExitButton.cliqued THEN EndApp
END SUB

SUB Manage.Button (Button AS Button)
IF MenuFocus THEN EXIT SUB
DIM OldState AS INTEGER
	OldState = Button.pressed
	NewState = MouseZOne(Button.x1, Button.y1, Button.x2, Button.y2) AND MouseClicLeft
	IF NewState <> OldState THEN
	      Button.pressed = NewState
	      MouseHide
	      Draw.Button Button
	      MouseShow
	END IF
	Button.cliqued = (OldState = -1) AND (NewState = 0) AND (MouseClicLeft = 0)
END SUB

SUB Manage.CheckBox (CheckBox AS CheckBox)
IF MenuFocus THEN EXIT SUB
	IF CheckBox.focused <> 1 AND MouseClicLeft AND MouseX >= CheckBox.cx - 5 AND MouseX <= CheckBox.cx + 5 AND MouseY >= CheckBox.cy - 5 AND MouseY <= CheckBox.cy + 5 THEN
			CheckBox.Selected = CheckBox.Selected XOR 1
			Draw.CheckBox CheckBox
			CheckBox.focused = 1
			EXIT SUB
	END IF
	IF (NOT MouseClicLeft) THEN
		CheckBox.focused = 0
	END IF
END SUB

SUB Manage.Icone (Icone AS Icone)
'il faut tou d'abord s'assurer qu'aucune autre icone est manage
'si une icone est manage ce doit tre celle ci
IF LockIcon AND (NOT Icone.focused) THEN EXIT SUB
Icone.cliqued = 0
IF MenuFocus THEN EXIT SUB
	IF Icone.focused THEN
		IF NOT MouseZOne(Icone.x - 7, Icone.y - 7, Icone.x + 7, Icone.y + 7) THEN
			MouseHide
				lx1 = Icone.x - 30
				ly1 = Icone.y - 30
				IF lx1 < 0 THEN lx1 = 0
				IF ly1 < 0 THEN ly1 = 0
				PUT (lx1, ly1), Icondata, PSET
			      Icone.focused = 0
			      Icone.pressed = 0
			      LockIcon = 0
			      Draw.Icone Icone
			MouseShow
			EXIT SUB
		END IF
		IF MouseClicLeft THEN
		      Icone.pressed = -1
		      LINE (Icone.x - 30, Icone.y - 30)-(Icone.x + 29, Icone.y + 29), 15, B
		      EXIT SUB
		ELSE
			IF Icone.pressed THEN
				Icone.cliqued = -1
				Icone.pressed = 0
				MouseHide
				lx1 = Icone.x - 30
				ly1 = Icone.y - 30
				IF lx1 < 0 THEN lx1 = 0
				IF ly1 < 0 THEN ly1 = 0
				PUT (lx1, ly1), Icondata, PSET
				Icone.focused = 0
				LockIcon = 0
				MouseShow

				EXIT SUB
			END IF
		END IF

	ELSE
		IF MouseZOne(Icone.x - 7, Icone.y - 7, Icone.x + 7, Icone.y + 7) THEN
			MouseHide
			      lx1 = Icone.x - 30
			      ly1 = Icone.y - 30
			      lx2 = Icone.x + 29
			      ly2 = Icone.y + 29
			      IF lx2 > 319 THEN lx2 = 319
			      IF ly2 > 199 THEN ly2 = 199
			      IF lx1 < 0 THEN lx1 = 0
			      IF ly1 < 0 THEN ly1 = 0
			      GET (lx1, ly1)-(lx2, ly2), Icondata
			      Icone.focused = -1
			      LockIcon = -1
			      Draw.Icone Icone
			MouseShow
			EXIT SUB
		END IF
	END IF
END SUB

SUB Manage.Menu
	IF MenuFocus THEN
		IF MouseClicLeft THEN
		    IF (NOT MouseZOne(MenuX1, MenuY1, MenuX2, MenuY2) AND MenuSelect = 0) THEN
			MenuFocus = 0
			MenuSelect = 0
			MenuSelected = 0
			MouseHide
			PUT (MenuX1, MenuY1), MenuData, PSET
			 MouseShow
			 EXIT SUB
		    END IF
		    IF MenuSelect = 0 THEN
			  MenuSelect = INT((MouseY - MenuY1 - 5) / 12) + 1
			  IF MenuSelect <= NbrMenuItem AND MenuSelect > 0 THEN
				MouseHide
				LINE (MenuX1 + 3, MenuY1 + 2 + ((MenuSelect - 1) * 12))-(MenuX2 - 3, MenuY1 + 14 + ((MenuSelect - 1) * 12)), 30, B
				MouseShow
				EXIT SUB
			   END IF
			   MenuSelect = 0
			   EXIT SUB
		    ELSE
			MenuSelect2 = INT((MouseY - MenuY1 - 5) / 12) + 1
			IF MenuSelect2 <= NbrMenuItem AND MenuSelect2 > 0 THEN
			  IF MenuSelect2 <> MenuSelect THEN
			   MouseHide
			   LINE (MenuX1 + 3, MenuY1 + 2 + ((MenuSelect - 1) * 12))-(MenuX2 - 3, MenuY1 + 14 + ((MenuSelect - 1) * 12)), 23, B
			   MenuSelect = MenuSelect2
			   LINE (MenuX1 + 3, MenuY1 + 2 + ((MenuSelect - 1) * 12))-(MenuX2 - 3, MenuY1 + 14 + ((MenuSelect - 1) * 12)), 30, B
			   MouseShow
			   EXIT SUB
			 END IF
			END IF
			  EXIT SUB
		    END IF
		   ELSE
			IF MenuSelect <> 0 THEN
				MenuFocus = 0
				MenuSelected = MenuSelect
				MenuSelect = 0
				MouseHide
					PUT (MenuX1, MenuY1), MenuData, PSET
				MouseShow
				EXIT SUB
			END IF
		END IF
	ELSE
	      Manage.Button MenuButton
	      IF MenuButton.cliqued THEN
	       IF MenuFocus = 0 THEN
		 MouseHide
		 GET (MenuX1, MenuY1)-(MenuX2, MenuY2), MenuData
		 Draw.Menu
		 MenuFocus = -1
		 MenuSelect = 0
		 MouseShow
		 EXIT SUB
		END IF
	       END IF
	END IF
END SUB

SUB Manage.TextBox (TextBox AS TextBox)
IF MenuFocus THEN EXIT SUB
	IF MouseClicLeft AND (MouseX >= TextBox.x1 AND MouseX <= TextBox.x2 AND MouseY >= TextBox.y1 AND MouseY <= TextBox.y2) THEN
		IF TextBox.focused = 0 THEN
			DO
			LOOP UNTIL INKEY$ = ""
			TextBox.focused = -1
			TextBox.OldText = LTRIM$(RTRIM$(TextBox.Texte))
			Draw.TextBox TextBox
		END IF
	END IF
	IF MouseClicLeft AND NOT (MouseX >= TextBox.x1 AND MouseX <= TextBox.x2 AND MouseY >= TextBox.y1 AND MouseY <= TextBox.y2) THEN
	      IF TextBox.focused = -1 THEN
			TextBox.focused = 0
			Draw.TextBox TextBox
	      END IF
	END IF

	IF TextBox.focused = -1 THEN
		a$ = INKEY$
		IF a$ <> "" THEN
		SELECT CASE a$
		   CASE CHR$(13)
			TextBox.focused = 0
			Draw.TextBox TextBox

		   CASE CHR$(8)
			IF TextBox.TextLen > 0 THEN
				TextBox.Texte = LEFT$(TextBox.Texte, TextBox.TextLen - 1)
				TextBox.TextLen = TextBox.TextLen - 1
				Draw.TextBox TextBox
			END IF

		   CASE CHR$(27)
			TextBox.focused = 0
			TextBox.Texte = TextBox.OldText
			TextBox.TextLen = LEN(LTRIM$(RTRIM$(TextBox.Texte)))
			Draw.TextBox TextBox
		   CASE ELSE
			IF ASC(a$) > 25 AND TextBox.TextLen < 255 THEN
				TextBox.Texte = LEFT$(TextBox.Texte, TextBox.TextLen) + a$
				TextBox.TextLen = TextBox.TextLen + 1
				Draw.TextBox TextBox
			END IF
		   END SELECT
		END IF
	END IF

END SUB

FUNCTION MouseClicLeft
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseClicLeft = ((regs.bx AND 1) = 1)
END FUNCTION

FUNCTION MouseClicRight
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseClicRight = ((regs.bx AND 2) = 2)
END FUNCTION

SUB MouseHide
	regs.ax = 2
	CALL INTERRUPT(&H33, regs, regs)
END SUB

SUB MouseShow
	regs.ax = 1
	CALL INTERRUPT(&H33, regs, regs)

END SUB

FUNCTION MouseTest
	regs.ax = 0
	CALL INTERRUPT(&H33, regs, regs)
	MouseTest = regs.ax
END FUNCTION

FUNCTION MouseX
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseX = (regs.cx) / 2
END FUNCTION

FUNCTION MouseY
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseY = regs.dx
END FUNCTION

FUNCTION MouseZOne (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER)
	 IF (MouseX >= x1 AND MouseX <= x2 AND MouseY >= y1 AND MouseY <= y2) THEN
		MouseZOne = -1
	 ELSE
		MouseZOne = 0
	 END IF
END FUNCTION

SUB setvar (inifile AS STRING, variable AS STRING, valeur AS STRING)

DIM chaine AS STRING
DIM nbrvars AS INTEGER
	 fic = FREEFILE
	 rep = -1
	 OPEN inifile FOR INPUT AS fic
	 nbrvars = 0
	 IF rep = -1 THEN
	 DO UNTIL EOF(fic)
	    LINE INPUT #fic, chaine
	    chaine = LTRIM$(RTRIM$(chaine))
	    nbrvars = nbrvars + 1
	 LOOP
	 END IF
	 CLOSE fic

	 DIM vartab(0 TO nbrvars) AS STRING

	IF nbrvars > 0 THEN
	 OPEN inifile FOR INPUT AS fic
	 FOR i = 0 TO nbrvars - 1
	    INPUT #fic, vartab(i)
	 NEXT i
	 CLOSE fic
       


	 FOR a = 0 TO nbrvars - 1
	       chaine = vartab(a)
	       chaine = LTRIM$(RTRIM$(chaine))
	       IF LEFT$(chaine, 1) <> "#" AND chaine <> "" THEN


		'on supprime les commentaires dans la ligne
		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "#" THEN
				chaine = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				
				EXIT FOR
			END IF
		NEXT i

		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "=" THEN
				variable1$ = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				IF variable1$ = variable THEN
					vartab(a) = variable1$ + " = " + valeur
					GOTO fin
				END IF
       
			END IF
       
		NEXT i
       
		END IF
	NEXT a
	nbrvars = nbrvars + 1
	vartab(nbrvars - 1) = variable + "=" + valeur
	GOTO fin
       ELSE
	nbrvars = 1
	vartab(nbrvars - 1) = variable + "=" + valeur
	GOTO fin
       END IF
fin:

fic = FREEFILE
OPEN inifile FOR OUTPUT AS fic

FOR i = 0 TO nbrvars - 1
	PRINT #fic, vartab(i)
NEXT i
CLOSE fic
END SUB

