DECLARE SUB saveLabel (Destination AS STRING, Source AS STRING, longueur AS INTEGER)
DECLARE SUB RestoreLabel (Source AS STRING, Destination AS STRING)
'$INCLUDE: 'includes\guilib.bi'
'$INCLUDE: 'includes\session.bi'
TYPE racourcis
	IconeName AS STRING * 50
	IconeFile AS STRING * 13
	IconeShelltype AS STRING * 3
	IconeSHell AS STRING * 100
END TYPE
DIM SHARED NbrIcons AS INTEGER
DIM MyLInk AS racourcis
DIM NextBtn AS button
DIM PrevBtn AS button
DIM AddBtn AS button
DIM DelBtn AS button

DIM LabelName AS TextBox
DIM LabelShell AS TextBox
DIM LabelFile AS button
DIM IsDos AS CheckBox
DIM IsGui AS CheckBox
DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER


App.SetTitle "Gestionaire D'icones"
Add.MenuItem "Quiter"
load.font sharedpath + "\fonte.bin"

xl = 200
yl = 100
x1 = (320 - xl) / 2
y1 = (200 - yl) / 2
x2 = x1 + xl
y2 = y1 + yl

Create.Button DelBtn, x1 + 25, y2 - 20, x1 + 40, y2 - 5, "-"
Create.Button AddBtn, x2 - 40, y2 - 20, x2 - 25, y2 - 5, "+"
Create.Button PrevBtn, x1 + 45, y2 - 20, x1 + 60, y2 - 5, "<"
Create.Button NextBtn, x2 - 60, y2 - 20, x2 - 45, y2 - 5, ">"
Create.TextBox LabelName, x1 + 85, y1 + 5, x2 - 5, y1 + 15, "", ""
Create.TextBox LabelShell, x1 + 85, y1 + 65, x2 - 5, y1 + 75, "", ""
Create.Button LabelFile, x1 + 5, y1 + 25, x1 + 50, y1 + 40, "Icone"
Create.CheckBox IsDos, x1 + 125, y1 + 54, 0
Create.CheckBox IsGui, x1 + 180, y1 + 54, 0
NbrIcons = VAL(getvar$(datapath + "\desktop.cfg", "nbricones"))
currentview = NbrIcons

GOSUB restoreview
SCREEN 13
cls.screen bgcolor
IF bgimage <> "" THEN load.bsv bgrdpath + "\" + LEFT$(bgimage, LEN(bgimage) - 4) + ".bsv"', 0, 0, 1
Draw.AppButtons
GOSUB drawview


DIM fichier AS STRING * 12
MouseShow
DO
Manage.Button AddBtn
	IF AddBtn.Cliqued THEN
		IF currentview > 0 THEN GOSUB saveview
		GOSUB addview
		GOSUB restoreview
		GOSUB drawview
		MouseShow
	END IF
IF NbrIcons > 0 THEN
	Manage.Button DelBtn
	IF NbrIcons > 1 THEN
	Manage.Button PrevBtn
	Manage.Button NextBtn
	END IF
	IF PrevBtn.Cliqued THEN
		GOSUB saveview
		currentview = currentview - 1
		IF currentview < 1 THEN currentview = NbrIcons
		GOSUB restoreview
		GOSUB drawview
	END IF

	IF NextBtn.Cliqued THEN
		GOSUB saveview
		currentview = currentview + 1
		IF currentview > NbrIcons THEN currentview = 1
		GOSUB restoreview
		GOSUB drawview
	END IF

	Manage.TextBox LabelName
	Manage.TextBox LabelShell
	Manage.Button LabelFile
	Manage.CheckBox IsDos
	Manage.CheckBox IsGui

	IF OldDosSelected <> IsDos.Selected THEN
		IsGui.Selected = IsGui.Selected XOR 1
		OldDosSelected = IsDos.Selected
		OldGuiSelected = IsGui.Selected
		Draw.CheckBox IsGui
	END IF

	IF OldGuiSelected <> IsGui.Selected THEN
		IsDos.Selected = IsDos.Selected XOR 1
		OldGuiSelected = IsGui.Selected
		OldDosSelected = IsDos.Selected
		Draw.CheckBox IsDos
	END IF

	IF LabelFile.Cliqued THEN
	 MouseHIde
	 SHELL binpath + "\iconsel"
	 MouseShow
	 OPEN "out.tmp" FOR BINARY AS 1
		GET #1, , fichier
	 CLOSE #1
	 IF LTRIM$(RTRIM$(fichier)) <> "none" THEN
	  MyLInk.IconeFile = fichier
	  LINE (x1 + 85, y1 + 20)-(x1 + 110, y1 + 45), 15, BF
	  LINE (x1 + 85, y1 + 20)-(x1 + 110, y1 + 45), 0, B
	  Draw.Pic iconspath + "\" + MyLInk.IconeFile, x1 + 90, y1 + 25, 1
	 END IF
	 MouseShow
	 KILL "out.tmp"
	END IF
	IF DelBtn.Cliqued THEN
	      IF currentview > 0 THEN GOSUB saveview
	      GOSUB delview
	      GOSUB restoreview
	      GOSUB drawview
	END IF
END IF

Manage.APP
MenuSelection = GetMenuSelected$
LOOP UNTIL MenuSelection = "Quiter"
GOSUB saveview
EndApp
SCREEN 0
WIDTH 80, 25
END



restoreview:
MyLInk.IconeName = LTRIM$(RTRIM$(getvar$(datapath + "\desktop.cfg", "iconename" + LTRIM$(RTRIM$(STR$(currentview))))))
MyLInk.IconeFile = LTRIM$(RTRIM$(getvar$(datapath + "\desktop.cfg", "iconefile" + LTRIM$(RTRIM$(STR$(currentview))))))
MyLInk.IconeSHell = LTRIM$(RTRIM$(getvar$(datapath + "\desktop.cfg", "iconeshell" + LTRIM$(RTRIM$(STR$(currentview))))))
MyLInk.IconeShelltype = LTRIM$(RTRIM$(getvar$(datapath + "\desktop.cfg", "iconeshelltype" + LTRIM$(RTRIM$(STR$(currentview))))))

LabelName.texte = LTRIM$(RTRIM$(MyLInk.IconeName))
LabelName.TextLen = LEN(LTRIM$(RTRIM$(MyLInk.IconeName)))
LabelShell.texte = LTRIM$(RTRIM$(MyLInk.IconeSHell))
LabelShell.TextLen = LEN(LTRIM$(RTRIM$(MyLInk.IconeSHell)))
IsGui.Selected = ABS(MyLInk.IconeShelltype = "gui")
IsDos.Selected = ABS(MyLInk.IconeShelltype = "dos")
OldDosSelected = IsDos.Selected
OldGuiSelected = IsGui.Selected

RETURN

saveview:
setvar datapath + "\desktop.cfg", "iconename" + LTRIM$(RTRIM$(STR$(currentview))), LTRIM$(RTRIM$(LabelName.texte))
setvar datapath + "\desktop.cfg", "iconefile" + LTRIM$(RTRIM$(STR$(currentview))), MyLInk.IconeFile
setvar datapath + "\desktop.cfg", "iconeshell" + LTRIM$(RTRIM$(STR$(currentview))), LTRIM$(RTRIM$(LabelShell.texte))
IF IsDos.Selected = 1 THEN setvar datapath + "\desktop.cfg", "iconeshelltype" + LTRIM$(RTRIM$(STR$(currentview))), "dos"
IF IsGui.Selected = 1 THEN setvar datapath + "\desktop.cfg", "iconeshelltype" + LTRIM$(RTRIM$(STR$(currentview))), "gui"
RETURN


drawview:
MouseHIde
Draw.frame x1, y1, x2, y2, 3
	Draw.Button DelBtn
	Draw.Button AddBtn
	Draw.Button PrevBtn
	Draw.Button NextBtn
	LINE (x1 + 65, y2 - 20)-(x2 - 65, y2 - 5), 15, BF
	LINE (x1 + 65, y2 - 20)-(x2 - 65, y2 - 5), 0, B
	Draw.texte STR$(currentview) + "\" + LTRIM$(RTRIM$(STR$(NbrIcons))), x1 + 70, y2 - 15, 0, 15

IF currentview > 0 THEN
	Draw.Button LabelFile
	Draw.texte "Nom     :", x1 + 10, y1 + 7, 0, 15
	Draw.texte "Commande:", x1 + 10, y1 + 67, 0, 15
	Draw.texte "Type    : Dos:   Gui:", x1 + 10, y1 + 50, 0, 15

	Draw.TextBox LabelName
	Draw.TextBox LabelShell
	IF LTRIM$(RTRIM$(MyLInk.IconeFile)) <> "" THEN
		LINE (x1 + 85, y1 + 20)-(x1 + 110, y1 + 45), 15, BF
		LINE (x1 + 85, y1 + 20)-(x1 + 110, y1 + 45), 0, B
		Draw.Pic iconspath + "\" + MyLInk.IconeFile, x1 + 90, y1 + 25, 1
	END IF
	Draw.CheckBox IsGui
	Draw.CheckBox IsDos
END IF
MouseShow
RETURN



delview:
	FOR i = currentview TO NbrIcons - 1
		setvar datapath + "\desktop.cfg", "iconename" + LTRIM$(RTRIM$(STR$(i))), getvar$(datapath + "\desktop.cfg", "iconename" + LTRIM$(RTRIM$(STR$(i + 1))))
		setvar datapath + "\desktop.cfg", "iconefile" + LTRIM$(RTRIM$(STR$(i))), getvar$(datapath + "\desktop.cfg", "iconefile" + LTRIM$(RTRIM$(STR$(i + 1))))
		setvar datapath + "\desktop.cfg", "iconeshell" + LTRIM$(RTRIM$(STR$(i))), getvar$(datapath + "\desktop.cfg", "iconeshell" + LTRIM$(RTRIM$(STR$(i + 1))))
		setvar datapath + "\desktop.cfg", "iconeshelltype" + LTRIM$(RTRIM$(STR$(i))), LTRIM$(RTRIM$(getvar$(datapath + "\desktop.cfg", "iconeshelltype" + LTRIM$(RTRIM$(STR$(i + 1))))))
	NEXT i
	NbrIcons = NbrIcons - 1
	setvar datapath + "\desktop.cfg", "nbricones", LTRIM$(RTRIM$(STR$(NbrIcons)))
	currentview = NbrIcons
RETURN


addview:
      NbrIcons = NbrIcons + 1
		setvar datapath + "\desktop.cfg", "iconename" + LTRIM$(RTRIM$(STR$(NbrIcons))), "none"
		setvar datapath + "\desktop.cfg", "iconefile" + LTRIM$(RTRIM$(STR$(NbrIcons))), "none"
		setvar datapath + "\desktop.cfg", "iconeshell" + LTRIM$(RTRIM$(STR$(NbrIcons))), "none"
		setvar datapath + "\desktop.cfg", "iconeshelltype" + LTRIM$(RTRIM$(STR$(NbrIcons))), "dos"
		setvar datapath + "\desktop.cfg", "nbricones", LTRIM$(RTRIM$(STR$(NbrIcons)))
      currentview = NbrIcons
RETURN

SUB saveLabel (Destination AS STRING, Source AS STRING, longueur AS INTEGER)
		Destination = LEFT$(LTRIM$(RTRIM$(Source)), longueur)
END SUB

