DECLARE FUNCTION crypt$ (chaine AS STRING, cle AS STRING)
DECLARE SUB saveLabel (Destination AS STRING, Source AS STRING, longueur AS INTEGER)
DECLARE SUB RestoreLabel (Source AS STRING, Destination AS STRING)
'$INCLUDE: 'includes\guilib.bi'
'$INCLUDE: 'includes\session.bi'
TYPE user
	nom AS STRING * 20
	password AS STRING * 20
	home AS STRING * 20
END TYPE

DIM SHARED nbrusers AS INTEGER
DIM YourUser(1 TO 20) AS user
DIM MyUser AS user
DIM NextBtn AS Button
DIM PrevBtn AS Button
DIM AddBtn AS Button
DIM DelBtn AS Button

DIM LabelName AS TextBox
DIM LabelPassword AS TextBox
DIM LabelHome AS TextBox
DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER

App.SetTitle "Utilisateurs"
Add.MenuItem "Quiter"
load.font sharedpath + "\fonte.bin"

xl = 200
yl = 100
x1 = (320 - xl) / 2
y1 = (200 - yl) / 2
x2 = x1 + xl
y2 = y1 + yl

Create.Button DelBtn, x1 + 25, y2 - 20, x1 + 40, y2 - 5, "-"
Create.Button AddBtn, x2 - 40, y2 - 20, x2 - 25, y2 - 5, "+"
Create.Button PrevBtn, x1 + 45, y2 - 20, x1 + 60, y2 - 5, "<"
Create.Button NextBtn, x2 - 60, y2 - 20, x2 - 45, y2 - 5, ">"
Create.TextBox LabelName, x1 + 85, y1 + 10, x2 - 5, y1 + 20, "", ""
Create.TextBox LabelPassword, x1 + 85, y1 + 35, x2 - 5, y1 + 45, "", "*"
Create.TextBox LabelHome, x1 + 85, y1 + 60, x2 - 5, y1 + 70, "", ""
cclkey$ = "kAbiRo"
fic = FREEFILE
OPEN sharedpath + "\users.cfg" FOR BINARY AS fic
	GET #fic, , nbrusers
	FOR i = 1 TO nbrusers
		GET #fic, , YourUser(i)
	NEXT i
CLOSE fic

currentview = nbrusers

GOSUB restoreview
SCREEN 13
cls.screen bgcolor
IF bgimage <> "" THEN load.bsv bgrdpath + "\" + LEFT$(bgimage, LEN(bgimage) - 4) + ".bsv"', 0, 0, 1
Draw.AppButtons
GOSUB drawview


DIM Fichier AS STRING * 12
MouseShow
DO
Manage.Button AddBtn
	IF AddBtn.cliqued THEN
		IF currentview > 0 THEN GOSUB saveview
		GOSUB addview
		GOSUB restoreview
		GOSUB drawview
		MouseShow
	END IF
IF nbrusers > 0 THEN
	Manage.Button DelBtn
	IF nbrusers > 1 THEN
	Manage.Button PrevBtn
	Manage.Button NextBtn
	END IF
	IF PrevBtn.cliqued THEN
		GOSUB saveview
		currentview = currentview - 1
		IF currentview < 1 THEN currentview = nbrusers
		GOSUB restoreview
		GOSUB drawview
	END IF

	IF NextBtn.cliqued THEN
		GOSUB saveview
		currentview = currentview + 1
		IF currentview > nbrusers THEN currentview = 1
		GOSUB restoreview
		GOSUB drawview
	END IF

	Manage.TextBox LabelName
	Manage.TextBox LabelPassword
	Manage.TextBox LabelHome
	IF DelBtn.cliqued THEN
		IF currentview > 0 THEN GOSUB saveview
	      GOSUB delview
	      GOSUB restoreview
	      GOSUB drawview
	END IF
END IF

Manage.APP
MenuSelection = GetMenuSelected$
LOOP UNTIL MenuSelection = "Quiter"
GOSUB saveview
EndApp
SCREEN 0
WIDTH 80, 25
END



restoreview:
MyUser.nom = LTRIM$(RTRIM$(YourUser(currentview).nom))
MyUser.password = crypt$(LTRIM$(RTRIM$(YourUser(currentview).password)), cclkey$)
MyUser.home = LTRIM$(RTRIM$(YourUser(currentview).home))

LabelName.Texte = LTRIM$(RTRIM$(MyUser.nom))
LabelName.TextLen = LEN(LTRIM$(RTRIM$(MyUser.nom)))
LabelPassword.Texte = LTRIM$(RTRIM$(MyUser.password))
LabelPassword.TextLen = LEN(LTRIM$(RTRIM$(MyUser.password)))
LabelHome.Texte = LTRIM$(RTRIM$(MyUser.home))
LabelHome.TextLen = LEN(LTRIM$(RTRIM$(MyUser.home)))
RETURN

saveview:
IF currentview = 0 THEN RETURN
MyUser.nom = LTRIM$(RTRIM$(LabelName.Texte))
MyUser.password = crypt$(LTRIM$(RTRIM$(LabelPassword.Texte)), cclkey$)
IF LTRIM$(RTRIM$(LabelHome.Texte)) <> LTRIM$(RTRIM$(MyUser.home)) THEN
		mypath$ = (LTRIM$(RTRIM$(LabelHome.Texte)))
		MKDIR mypath$
		MKDIR mypath$ + "\data"
		fic = FREEFILE
		OPEN mypath$ + "\data\desktop.cfg" FOR BINARY AS fic
		CLOSE fic
	END IF
MyUser.home = LTRIM$(RTRIM$(LabelHome.Texte))
YourUser(currentview) = MyUser
OPEN sharedpath + "\users.cfg" FOR BINARY AS fic
	PUT #fic, , nbrusers
	FOR i = 1 TO nbrusers
		PUT #fic, , YourUser(i)
	NEXT i
CLOSE fic
RETURN

drawview:
LOCATE 1, 1
MouseHide
Draw.frame x1, y1, x2, y2, 3
	Draw.Button DelBtn
	Draw.Button AddBtn
	Draw.Button PrevBtn
	Draw.Button NextBtn
	LINE (x1 + 65, y2 - 20)-(x2 - 65, y2 - 5), 15, BF
	LINE (x1 + 65, y2 - 20)-(x2 - 65, y2 - 5), 0, B
	Draw.texte STR$(currentview) + "\" + LTRIM$(RTRIM$(STR$(nbrusers))), x1 + 70, y2 - 15, 0, 15
IF currentview > 0 THEN
	Draw.texte "Nom     :", x1 + 10, y1 + 12, 0, 15
	Draw.texte "Password:", x1 + 10, y1 + 37, 0, 15
	Draw.texte "Path    :", x1 + 10, y1 + 62, 0, 15

	Draw.TextBox LabelName
	Draw.TextBox LabelPassword
	Draw.TextBox LabelHome
END IF
MouseShow
RETURN


delview:
	nbrusers = nbrusers - 1
	FOR i = currentview TO nbrusers - 1
		YourUser(i) = YourUser(i + 1)
	NEXT i
	NbrUser = NbrUser - 1
	currentview = nbrusers
RETURN


addview:
      nbrusers = nbrusers + 1
      YourUser(nbrusers).nom = ""
      YourUser(nbrusers).password = ""
      YourUser(nbrusers).home = ""
		currentview = nbrusers
RETURN

FUNCTION crypt$ (chaine AS STRING, cle AS STRING)
c$ = ""
	FOR i = 1 TO LEN(chaine)
		j = (i MOD LEN(cle)) + 1
		c$ = c$ + CHR$(ASC(MID$(chaine, i, 1)) XOR ASC(MID$(cle, j, 1)) XOR 42)
	NEXT i
	crypt$ = c$
END FUNCTION

SUB saveLabel (Destination AS STRING, Source AS STRING, longueur AS INTEGER)
		Destination = LEFT$(LTRIM$(RTRIM$(Source)), longueur)
END SUB

